#include <ESP8266WiFi.h>   //подключение билиотеки
#include <PubSubClient.h>  //подключение библитеки для работы протокола MQTT
#include <Servo.h>
#define PIN_SERVO D4

WiFiClient esp;
PubSubClient board(esp);  //создание объекта боард
Servo myservo;
int flag = 0;

void receive_message(char* topic, byte* payload, int length) {
  myservo.write(0);  // tell servo to go to position in variable 'pos'
  delay(3000);
  myservo.write(180);  // tell servo to go to position in variable 'pos'
  delay(1000);
  board.publish("naliv", "stop");  //и отправим на брокер сообщение о подключении
}

void setup() {
  Serial.begin(9600);
  WiFi.begin("dima", "12345678");   // подключение платы к WIFI
  pinMode(LED_BUILTIN, OUTPUT);             //настройка пина
  board.setServer("95.163.230.191", 1883);  //установка адреса и порта
  board.setCallback(receive_message);       //вызов функции при принятии сообщения
  myservo.attach(PIN_SERVO);
}

void loop() {
  if (WiFi.status() == WL_CONNECTED && board.connected() != 0)  //если плата подключена к WIFI и к брокеру
  {
    digitalWrite(LED_BUILTIN, LOW);  // то включаем светодио
    if (flag == 0) {
      board.publish("naliv", "ready");  //и отправим на брокер сообщение о подключении
      flag = 1;
    }
  } else if (WiFi.status() == WL_CONNECTED && board.connected() == 0)  //если плата подключена к WIFI, но не к брокеру
  {
    board.connect("esp_we13", "maker", "LABmaker123");  // то подключаемся к брокеру
    board.subscribe("naliv_2");                         //подклюимся к топику для принятия сообщения
    digitalWrite(LED_BUILTIN, LOW);                     // и включаем светодиод
    delay(1000);
    digitalWrite(LED_BUILTIN, HIGH);
    delay(1000);
  } else {
    digitalWrite(LED_BUILTIN, HIGH);  // выключаем свтеодиод, если не подключены к WIFI
    Serial.println("no");
  }
  board.loop();
}